package com.zsElectric.boot.business.service.impl;

import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zsElectric.boot.business.mapper.UserInfoMapper;
import com.zsElectric.boot.business.service.UserInfoService;
import com.zsElectric.boot.business.model.entity.UserInfo;
import com.zsElectric.boot.business.model.form.UserInfoForm;
import com.zsElectric.boot.business.model.query.UserInfoQuery;
import com.zsElectric.boot.business.model.vo.UserInfoVO;
import com.zsElectric.boot.business.converter.UserInfoConverter;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

import cn.hutool.core.lang.Assert;
import cn.hutool.core.util.StrUtil;

/**
 * 个人用户信息服务实现类
 *
 * @author zsElectric
 * @since 2025-12-12 10:27
 */
@Service
@RequiredArgsConstructor
public class UserInfoServiceImpl extends ServiceImpl<UserInfoMapper, UserInfo> implements UserInfoService {

    private final UserInfoConverter userInfoConverter;

    /**
    * 获取个人用户信息分页列表
    *
    * @param queryParams 查询参数
    * @return {@link IPage<UserInfoVO>} 个人用户信息分页列表
    */
    @Override
    public IPage<UserInfoVO> getUserInfoPage(UserInfoQuery queryParams) {
        Page<UserInfoVO> pageVO = this.baseMapper.getUserInfoPage(
                new Page<>(queryParams.getPageNum(), queryParams.getPageSize()),
                queryParams
        );
        return pageVO;
    }
    
    /**
     * 获取个人用户信息表单数据
     *
     * @param id 个人用户信息ID
     * @return 个人用户信息表单数据
     */
    @Override
    public UserInfoForm getUserInfoFormData(Long id) {
        UserInfo entity = this.getById(id);
        return userInfoConverter.toForm(entity);
    }
    
    /**
     * 新增个人用户信息
     *
     * @param formData 个人用户信息表单对象
     * @return 是否新增成功
     */
    @Override
    public boolean saveUserInfo(UserInfoForm formData) {
        UserInfo entity = userInfoConverter.toEntity(formData);
        return this.save(entity);
    }
    
    /**
     * 更新个人用户信息
     *
     * @param id   个人用户信息ID
     * @param formData 个人用户信息表单对象
     * @return 是否修改成功
     */
    @Override
    public boolean updateUserInfo(Long id,UserInfoForm formData) {
        UserInfo entity = userInfoConverter.toEntity(formData);
        return this.updateById(entity);
    }
    
    /**
     * 删除个人用户信息
     *
     * @param ids 个人用户信息ID，多个以英文逗号(,)分割
     * @return 是否删除成功
     */
    @Override
    public boolean deleteUserInfos(String ids) {
        Assert.isTrue(StrUtil.isNotBlank(ids), "删除的个人用户信息数据为空");
        // 逻辑删除
        List<Long> idList = Arrays.stream(ids.split(","))
                .map(Long::parseLong)
                .toList();
        return this.removeByIds(idList);
    }

}
